## pgcopydb 0.3

=== debian/changelog ===
pgcopydb (0.3-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 24 Jan 2022 13:22:59 +0100

pgcopydb (0.3-1) unstable; urgency=low

  * Official 0.3 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 24 Jan 2022 13:22:59 +0100

pgcopydb (0.2-1) unstable; urgency=low

  * Official 0.2 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 13 Jan 2022 15:43:49 +0100

pgcopydb (0.1-1) unstable; urgency=low

  * Official 0.1 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 13 Jan 2022 12:14:26 +0100

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_build:
	$(MAKE) -C src/bin/pgcopydb
	$(MAKE) -C docs man

override_dh_auto_clean:
	$(MAKE) -C src/bin/pgcopydb clean
	$(MAKE) -C docs clean

override_dh_auto_test:
	PATH=$(CURDIR)/src/bin/pgcopydb:$(PATH) debian/tests/copydb

override_dh_auto_install:
	$(MAKE) -C src/bin/pgcopydb install \
		DESTDIR=$(CURDIR)/debian/pgcopydb \
		BINDIR=/usr/bin

override_dh_installman:
	dh_installman docs/_build/man/*

%:
	dh $@

## pgcopydb 0.8

=== Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

all: bin ;

GIT-VERSION-FILE:
	@$(SHELL_PATH) ./GIT-VERSION-GEN

-include GIT-VERSION-FILE

bin: GIT-VERSION-FILE
	$(MAKE) -C src/bin/ all

clean:
	rm -f GIT-VERSION-FILE
	$(MAKE) -C src/bin/ clean

docs:
	$(MAKE) -C docs clean man html

test: build
	$(MAKE) -C tests all

tests: test ;

tests/ci:
	sh ./ci/banned.h.sh

tests/*: build
	$(MAKE) -C $@

install: bin
	$(MAKE) -C src/bin/ install

indent:
	citus_indent

build:
	docker build -t pgcopydb .

# debian packages built from the current sources
deb:
	docker build -f Dockerfile.debian -t pgcopydb_debian .

debsh: deb
	docker run --rm -it pgcopydb_debian bash

# debian packages built from latest tag, manually maintained in the Dockerfile
deb-qa:
	docker build -f Dockerfile.debian-qa -t pgcopydb_debian_qa .

debsh-qa: deb-qa
	docker run --rm -it pgcopydb_debian_qa bash

.PHONY: all
.PHONY: bin clean install docs
.PHONY: test tests tests/ci tests/*
.PHONY: deb debsh deb-qa debsh-qa
.PHONY: GIT-VERSION-FILE

=== tests/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

all: pagila pagila-multi-steps blobs unit filtering cdc ;

pagila: build
	$(MAKE) -C pagila

pagila-multi-steps: build
	$(MAKE) -C pagila-multi-steps

blobs:
	$(MAKE) -C blobs

unit:
	$(MAKE) -C unit

filtering:
	$(MAKE) -C filtering

cdc: build
	$(MAKE) -C cdc

follow: build
	$(MAKE) -C cdc

build:
	docker build -t pagila -f Dockerfile.pagila .

.PHONY: all build
.PHONY: pagila pagila-multi-steps blobs unit filtering cdc follow

=== tests/blobs/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

INTERACTIVE_OPTS = --abort-on-container-exit --exit-code-from pgcopydb

test: build down up down ;

up:
	docker-compose up $(INTERACTIVE_OPTS)

down:
	docker-compose down

build:
	docker-compose build

import:
	psql --single-transaction --no-psqlrc -f import.sql


.PHONY: up down build test import

=== tests/cdc/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

INTERACTIVE_OPTS = --abort-on-container-exit --exit-code-from pgcopydb

test: build down up down ;

up:
	docker-compose up $(INTERACTIVE_OPTS)

down:
	docker-compose down

build:
	$(MAKE) -C .. build
	docker-compose build

.PHONY: up down build test

=== tests/filtering/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

INTERACTIVE_OPTS = --abort-on-container-exit --exit-code-from pgcopydb

test: build down up down ;

up:
	docker-compose up $(INTERACTIVE_OPTS)

down:
	docker-compose down

build:
	docker-compose build

.PHONY: up down build test

=== tests/unit/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

INTERACTIVE_OPTS = --abort-on-container-exit --exit-code-from pgcopydb

test: build down up down ;

up:
	docker-compose up $(INTERACTIVE_OPTS)

down:
	docker-compose down

build:
	docker-compose build


.PHONY: up down build test

=== debian/changelog ===
pgcopydb (0.8-1.pgdg90+~20220721.2039.g0235693) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 20 Jul 2022 11:14:18 +0200

pgcopydb (0.8-1) unstable; urgency=low

  * Official 0.8 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 20 Jul 2022 11:14:18 +0200

pgcopydb (0.7-3) UNRELEASED; urgency=medium

  * debian/tests/copydb: Put temp files into debian/home.

 -- Christoph Berg <myon@debian.org>  Thu, 30 Jun 2022 10:53:18 +0200

pgcopydb (0.7-2) unstable; urgency=medium

  * Update copyright of src/bin/lib/pg/snprintf.c and src/bin/lib/libs.

 -- Christoph Berg <myon@debian.org>  Mon, 27 Jun 2022 16:11:21 +0200

pgcopydb (0.7-1) unstable; urgency=low

  * Official 0.7 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 24 May 2022 15:47:40 +0200

pgcopydb (0.6-1) unstable; urgency=low

  * Official 0.6 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 16 May 2022 14:17:39 +0200

pgcopydb (0.5-1) unstable; urgency=low

  * Official 0.5 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 11 Mar 2022 12:22:46 +0100

pgcopydb (0.4-1) unstable; urgency=low

  * Official 0.4 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 08 Mar 2022 16:33:46 +0100

=== debian/control ===
Source: pgcopydb
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper (>= 10),
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 postgresql,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.6.0
Homepage: https://github.com/dimitri/pgcopydb
Vcs-Browser: https://github.com/dimitri/pgcopydb
Vcs-Git: https://github.com/dimitri/pgcopydb.git

Package: pgcopydb
Architecture: any
Depends:
 postgresql-client,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Copy an entire PostgreSQL database from source to target
 This tool copies an entire PostgreSQL database from source to target. It
 implements `pg_dump | pg_restore` on steroids, including advanced concurrency
 tricks to make the operation faster.

## pgcopydb 0.10

=== Makefile ===
--- 
+++ 
@@ -6,9 +6,7 @@
 all: bin ;
 
 GIT-VERSION-FILE:
-	@$(SHELL_PATH) ./GIT-VERSION-GEN
-
--include GIT-VERSION-FILE
+	@$(SHELL_PATH) ./GIT-VERSION-GEN > /dev/null 2>&1
 
 bin: GIT-VERSION-FILE
 	$(MAKE) -C src/bin/ all
@@ -16,6 +14,9 @@
 clean:
 	rm -f GIT-VERSION-FILE
 	$(MAKE) -C src/bin/ clean
+
+maintainer-clean: clean
+	rm -f version
 
 docs:
 	$(MAKE) -C docs clean man html
@@ -29,7 +30,7 @@
 	sh ./ci/banned.h.sh
 
 tests/*: build
-	$(MAKE) -C $@
+	$(MAKE) -C tests $(notdir $@)
 
 install: bin
 	$(MAKE) -C src/bin/ install
@@ -37,8 +38,15 @@
 indent:
 	citus_indent
 
-build:
+build: version
 	docker build -t pgcopydb .
+
+echo-version: GIT-VERSION-FILE
+	@awk '{print $$3}' $<
+
+version: GIT-VERSION-FILE
+	@awk '{print $$3}' $< > $@
+	@cat $@
 
 # debian packages built from the current sources
 deb:
@@ -55,7 +63,7 @@
 	docker run --rm -it pgcopydb_debian_qa bash
 
 .PHONY: all
-.PHONY: bin clean install docs
+.PHONY: bin clean install docs maintainer-clean
 .PHONY: test tests tests/ci tests/*
 .PHONY: deb debsh deb-qa debsh-qa
 .PHONY: GIT-VERSION-FILE

=== tests/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

all: pagila pagila-multi-steps blobs unit filtering cdc follow extensions ;

pagila: build
	$(MAKE) -C $@

pagila-multi-steps: build
	$(MAKE) -C $@

blobs: build
	$(MAKE) -C $@

unit: build
	$(MAKE) -C $@

filtering: build
	$(MAKE) -C $@

cdc: build
	$(MAKE) -C $@

follow: build
	$(MAKE) -C $@

follow-9.6: build
	$(MAKE) -C $@

extensions: build
	$(MAKE) -C $@

build:
	docker build -t pagila -f Dockerfile.pagila .

.PHONY: all build
.PHONY: pagila pagila-multi-steps blobs unit filtering cdc follow extensions

=== tests/blobs/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

test: down run down ;

run: build
	docker-compose run test

down:
	docker-compose down

build:
	docker-compose build --quiet

import:
	psql --single-transaction --no-psqlrc -f import.sql


.PHONY: run down build test import

=== tests/follow-9.6/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

PGVERSION ?= 9.6
COMPOSE_EXIT = --exit-code-from=test --abort-on-container-exit

test: down run down ;

up: down build
	PGVERSION=$(PGVERSION) docker-compose up $(COMPOSE_EXIT)

run: build
	PGVERSION=$(PGVERSION) docker-compose run test

down:
	docker-compose down

build:
	PGVERSION=$(PGVERSION) docker-compose build

.PHONY: run down build test

=== tests/pagila/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

test: down run down ;

run: build
	docker-compose run test

down:
	docker-compose down

build:
	docker-compose build --quiet

.PHONY: down build test

=== src/bin/pgcopydb/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

PGCOPYDB = ./pgcopydb

SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

-include $(SRC_DIR)../../../GIT-VERSION-FILE

DEPDIR = $(SRC_DIR)/.deps

INCLUDES  = $(patsubst ${SRC_DIR}%.h,%.h,$(wildcard ${SRC_DIR}*.h))

SRC   = $(patsubst ${SRC_DIR}%.c,%.c,$(wildcard ${SRC_DIR}*.c))
OBJS  = $(patsubst %.c,%.o,$(SRC))
OBJS += lib-log.o lib-commandline.o lib-parson.o lib-snprintf.o lib-strerror.o

PG_CONFIG ?= pg_config
BINDIR    ?= $(shell $(PG_CONFIG) --bindir)

PG_SNPRINTF     = $(wildcard ${SRC_DIR}../lib/pg/snprintf.*)
LOG_SRC         = $(wildcard ${SRC_DIR}../lib/log/src/log.*)
COMMANDLINE_SRC = $(wildcard ${SRC_DIR}../lib/subcommands.c/commandline.*)
PARSON_SRC      = $(wildcard ${SRC_DIR}../lib/parson/parson.*)

COMMON_LIBS  = -I${SRC_DIR}../lib/pg
COMMON_LIBS += -I${SRC_DIR}../lib/log/src/
COMMON_LIBS += -I${SRC_DIR}../lib/subcommands.c/
COMMON_LIBS += -I${SRC_DIR}../lib/libs/
COMMON_LIBS += -I${SRC_DIR}../lib/parson/
COMMON_LIBS += -I${SRC_DIR}../lib/uthash

CC = $(shell $(PG_CONFIG) --cc)

DEFAULT_CFLAGS = -std=c99 -D_GNU_SOURCE -g
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir-server)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --pkgincludedir)/internal
DEFAULT_CFLAGS += $(shell $(PG_CONFIG) --cflags)
DEFAULT_CFLAGS += -Wformat
DEFAULT_CFLAGS += -Wall
DEFAULT_CFLAGS += -Werror=implicit-int
DEFAULT_CFLAGS += -Werror=implicit-function-declaration
DEFAULT_CFLAGS += -Werror=return-type
DEFAULT_CFLAGS += -Wno-declaration-after-statement

# Needed for FreeBSD
DEFAULT_CFLAGS += -D_WANT_SEMUN

# Needed for OSX
DEFAULT_CFLAGS += -Wno-missing-braces
DEFAULT_CFLAGS += $(COMMON_LIBS)

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpie -Wl,-pie -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
endif

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)

LIBS  = -L $(shell $(PG_CONFIG) --pkglibdir)
LIBS += -L $(shell $(PG_CONFIG) --libdir)
LIBS += $(shell $(PG_CONFIG) --ldflags)
LIBS += $(shell $(PG_CONFIG) --libs)
LIBS += -lpq
LIBS += -lncurses

all: $(PGCOPYDB) ;

# Based on Postgres Makefile for automatic dependency generation
# https://github.com/postgres/postgres/blob/1933ae629e7b706c6c23673a381e778819db307d/src/Makefile.global.in#L890-L924
%.o : %.c
	@if test ! -d $(DEPDIR); then mkdir -p $(DEPDIR); fi
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -o $@ $<

Po_files := $(wildcard $(DEPDIR)/*.Po)
ifneq (,$(Po_files))
include $(Po_files)
endif


$(PGCOPYDB): VERSION-FILE $(OBJS) $(INCLUDES)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(LIBS) -o $@

lib-snprintf.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/snprintf.c

lib-strerror.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/strerror.c

lib-log.o: $(LOG_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/log/src/log.c

lib-commandline.o: $(COMMANDLINE_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/subcommands.c/commandline.c

lib-parson.o: $(PARSON_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/parson/parson.c

VERSION-FILE: git-version.h ;

git-version.h:
	echo "#define GIT_VERSION \""$(GIT_VERSION)"\"" > $@

clean:
	rm -f git-version.h
	rm -f $(OBJS) $(PGCOPYDB)
	rm -rf $(DEPDIR)

install: $(PGCOPYDB)
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 $(PGCOPYDB) $(DESTDIR)$(BINDIR)



.PHONY: all monitor clean
.PHONY: VERSION-FILE

=== debian/changelog ===
pgcopydb (0.10-1) unstable; urgency=medium

  * B-D on libzstd-dev. (Closes: #1022290)

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 03 Nov 2022 15:00:41 +0100

pgcopydb (0.9-1) unstable; urgency=low

  * Official 0.9 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Fri, 30 Sep 2022 12:16:46 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 13),
  libedit-dev,
  libkrb5-dev,
  liblz4-dev,
@@ -15,6 +15,7 @@
  libselinux1-dev,
  libssl-dev,
  libxslt1-dev,
+ libzstd-dev,
  postgresql,
  postgresql-server-dev-all (>= 158~),
  python3-sphinx,

=== debian/watch ===
version=4
https://github.com/dimitri/pgcopydb/tags .*/v(.*).tar.gz

## pgcopydb 0.11

=== debian/changelog ===
pgcopydb (0.11-1) experimental; urgency=medium

  * Official 0.11 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 15 Mar 2023 13:42:58 +0100

## pgcopydb 0.13

=== tests/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

all: pagila pagila-multi-steps blobs unit filtering cdc follow extensions cdc-endpos-between-transaction;

pagila: build
	$(MAKE) -C $@

pagila-multi-steps: build
	$(MAKE) -C $@

blobs: build
	$(MAKE) -C $@

unit: build
	$(MAKE) -C $@

filtering: build
	$(MAKE) -C $@

cdc-wal2json: build
	$(MAKE) -C $@

cdc-test-decoding: build
	$(MAKE) -C $@

cdc-endpos-between-transaction: build
	$(MAKE) -C $@

cdc-low-level: build
	$(MAKE) -C $@

follow-wal2json: build
	$(MAKE) -C $@

follow-9.6: build
	$(MAKE) -C $@

extensions: build
	$(MAKE) -C $@

follow-data-only: build
	$(MAKE) -C $@

build:
	docker build -t pagila -f Dockerfile.pagila .

.PHONY: all build
.PHONY: pagila pagila-multi-steps blobs unit filtering extensions
.PHONY: cdc-wal2json cdc-test-decoding cdc-low-level
.PHONY: follow-wal2json follow-9.6

=== debian/changelog ===
pgcopydb (0.13-1) unstable; urgency=medium

  * Official 0.13 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 27 Jul 2023 16:34:14 +0200

pgcopydb (0.12-1) unstable; urgency=medium

  * Official 0.12 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 28 Jun 2023 12:23:11 +0200

pgcopydb (0.11-1) unstable; urgency=medium

  * Official 0.11 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 15 Mar 2023 13:42:58 +0100

## pgcopydb 0.14

=== tests/Makefile ===
--- 
+++ 
@@ -1,5 +1,8 @@
 # Copyright (c) 2021 The PostgreSQL Global Development Group.
 # Licensed under the PostgreSQL License.
+
+PGVERSION ?= 16
+BUILD_ARGS = --build-arg PGVERSION=$(PGVERSION)
 
 all: pagila pagila-multi-steps blobs unit filtering cdc follow extensions cdc-endpos-between-transaction;
 
@@ -43,7 +46,7 @@
 	$(MAKE) -C $@
 
 build:
-	docker build -t pagila -f Dockerfile.pagila .
+	docker build $(BUILD_ARGS) -t pagila -f Dockerfile.pagila .
 
 .PHONY: all build
 .PHONY: pagila pagila-multi-steps blobs unit filtering extensions

=== src/bin/pgcopydb/Makefile ===
--- 
+++ 
@@ -13,22 +13,27 @@
 
 SRC   = $(patsubst ${SRC_DIR}%.c,%.c,$(wildcard ${SRC_DIR}*.c))
 OBJS  = $(patsubst %.c,%.o,$(SRC))
-OBJS += lib-log.o lib-commandline.o lib-parson.o lib-snprintf.o lib-strerror.o
+OBJS += lib-log.o lib-commandline.o lib-parson.o
+OBJS += lib-snprintf.o lib-strerror.o lib-dumputils.o lib-string_utils.o
+OBJS += lib-lookup3.o
 
 PG_CONFIG ?= pg_config
 BINDIR    ?= $(shell $(PG_CONFIG) --bindir)
 
 PG_SNPRINTF     = $(wildcard ${SRC_DIR}../lib/pg/snprintf.*)
+PG_DUMPUTILS    = $(wildcard ${SRC_DIR}../lib/pg/*utils.*)
 LOG_SRC         = $(wildcard ${SRC_DIR}../lib/log/src/log.*)
 COMMANDLINE_SRC = $(wildcard ${SRC_DIR}../lib/subcommands.c/commandline.*)
 PARSON_SRC      = $(wildcard ${SRC_DIR}../lib/parson/parson.*)
+JENKINS_SRC     = $(wildcard ${SRC_DIR}../lib/jenkins/lookup3.*)
 
 COMMON_LIBS  = -I${SRC_DIR}../lib/pg
 COMMON_LIBS += -I${SRC_DIR}../lib/log/src/
 COMMON_LIBS += -I${SRC_DIR}../lib/subcommands.c/
 COMMON_LIBS += -I${SRC_DIR}../lib/libs/
 COMMON_LIBS += -I${SRC_DIR}../lib/parson/
-COMMON_LIBS += -I${SRC_DIR}../lib/uthash
+COMMON_LIBS += -I${SRC_DIR}../lib/uthash/
+COMMON_LIBS += -I${SRC_DIR}../lib/jenkins/
 
 CC = $(shell $(PG_CONFIG) --cc)
 
@@ -58,6 +63,8 @@
 endif
 
 override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)
+
+JENKINS_CFLAGS = $(CFAGS) -Wno-implicit-fallthrough -Wno-format
 
 LIBS  = -L $(shell $(PG_CONFIG) --pkglibdir)
 LIBS += -L $(shell $(PG_CONFIG) --libdir)
@@ -89,6 +96,12 @@
 lib-strerror.o: $(PG_SNPRINTF)
 	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/strerror.c
 
+lib-dumputils.o: $(PG_DUMPUTILS)
+	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/dumputils.c
+
+lib-string_utils.o: $(PG_DUMPUTILS)
+	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/string_utils.c
+
 lib-log.o: $(LOG_SRC)
 	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/log/src/log.c
 
@@ -97,6 +110,9 @@
 
 lib-parson.o: $(PARSON_SRC)
 	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/parson/parson.c
+
+lib-lookup3.o: $(JENKINS_SRC)
+	$(CC) $(JENKINS_CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/jenkins/lookup3.c
 
 VERSION-FILE: git-version.h ;

=== debian/changelog ===
pgcopydb (0.14-1.pgdg20.04+~20240110.1356.g600116d) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 20 Nov 2023 15:15:43 +0100

pgcopydb (0.14-1) unstable; urgency=medium

  * Official 0.14 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 20 Nov 2023 15:15:43 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 12),
  libedit-dev,
  libkrb5-dev,
  liblz4-dev,
@@ -13,6 +13,7 @@
  libpam0g-dev,
  libreadline-dev,
  libselinux1-dev,
+ libsqlite3-dev,
  libssl-dev,
  libxslt1-dev,
  libzstd-dev,

## pgcopydb 0.15

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,9 @@
 
 docs:
 	$(MAKE) -C docs clean man html
+
+update-docs: install
+	bash ./docs/update-help-messages.sh
 
 test: build
 	$(MAKE) -C tests all

=== tests/Makefile ===
--- 
+++ 
@@ -4,7 +4,10 @@
 PGVERSION ?= 16
 BUILD_ARGS = --build-arg PGVERSION=$(PGVERSION)
 
-all: pagila pagila-multi-steps blobs unit filtering cdc follow extensions cdc-endpos-between-transaction;
+all: pagila pagila-multi-steps blobs unit filtering extensions \
+	 cdc-wal2json cdc-test-decoding cdc-endpos-between-transaction cdc-low-level \
+	 follow-wal2json follow-9.6 follow-data-only \
+	 endpos-in-multi-wal-txn;
 
 pagila: build
 	$(MAKE) -C $@
@@ -19,6 +22,9 @@
 	$(MAKE) -C $@
 
 filtering: build
+	$(MAKE) -C $@
+
+extensions: build
 	$(MAKE) -C $@
 
 cdc-wal2json: build
@@ -39,10 +45,10 @@
 follow-9.6: build
 	$(MAKE) -C $@
 
-extensions: build
+follow-data-only: build
 	$(MAKE) -C $@
 
-follow-data-only: build
+endpos-in-multi-wal-txn: build
 	$(MAKE) -C $@
 
 build:
@@ -52,3 +58,4 @@
 .PHONY: pagila pagila-multi-steps blobs unit filtering extensions
 .PHONY: cdc-wal2json cdc-test-decoding cdc-low-level
 .PHONY: follow-wal2json follow-9.6
+.PHONY: endpos-in-multi-wal-txn

=== src/bin/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

all: pgcopydb ;

pgcopydb:
	$(MAKE) -C pgcopydb pgcopydb

clean:
	$(MAKE) -C pgcopydb clean

install: $(pgcopydb)
	$(MAKE) -C pgcopydb install

.PHONY: all pgcopydb install clean

=== tests/cdc-endpos-between-transaction/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

test: down run down ;

run: build
	docker-compose run test

down:
	docker-compose down

build:
	docker-compose build --quiet

.PHONY: run down build test

=== tests/cdc-wal2json/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

COMPOSE_EXIT = --exit-code-from=test --abort-on-container-exit

test: down run down ;

up: down build
	docker-compose up $(COMPOSE_EXIT)

run: build
	docker-compose run test

down:
	docker-compose down

build:
	docker-compose build --quiet

.PHONY: run down build test

=== tests/follow-9.6/Makefile ===
--- 
+++ 
@@ -14,6 +14,7 @@
 
 down:
 	docker-compose down
+	rm -rf workdir/pgcopydb
 
 build:
 	PGVERSION=$(PGVERSION) docker-compose build

=== tests/follow-data-only/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

COMPOSE_EXIT = --exit-code-from=test --abort-on-container-exit

test: down run down ;

up: down build
	docker-compose up $(COMPOSE_EXIT)

run: build
	docker-compose run test

down:
	docker-compose down
	rm -rf workdir/pgcopydb

build:
	docker-compose build --quiet

.PHONY: run down build test

=== src/bin/pgcopydb/Makefile ===
--- 
+++ 
@@ -49,6 +49,13 @@
 DEFAULT_CFLAGS += -Werror=return-type
 DEFAULT_CFLAGS += -Wno-declaration-after-statement
 
+ifdef DEBUG
+# Use optimization option that provides good debugging experience
+# https://gcc.gnu.org/onlinedocs/gcc/Optimize-Options.html.
+# It overrides '-O2' flag of pg_config.
+DEFAULT_CFLAGS += -Og
+endif
+
 # Needed for FreeBSD
 DEFAULT_CFLAGS += -D_WANT_SEMUN
 
@@ -72,6 +79,7 @@
 LIBS += $(shell $(PG_CONFIG) --libs)
 LIBS += -lpq
 LIBS += -lncurses
+LIBS += -lsqlite3
 
 all: $(PGCOPYDB) ;

=== src/bin/lib/jenkins/Makefile ===
all: clean lookup3 test ;

test: lookup3
	./lookup3

lookup3.o: lookup3.c
	$(CC) -c -o $@ $<

lookup3: lookup3.c
	$(CC) -D SELF_TEST -Wno-implicit-fallthrough -Wno-format -o $@ $<

clean:
	rm -f lookup3.o lookup3

.PHONY: all clean test

=== src/bin/lib/parson/Makefile ===
CC = gcc
CFLAGS = -O0 -g -Wall -Wextra -std=c89 -pedantic-errors -DTESTS_MAIN

CPPC = g++
CPPFLAGS = -O0 -g -Wall -Wextra -DTESTS_MAIN 

all: test testcpp test_hash_collisions

.PHONY: test testcpp test_hash_collisions
test: tests.c parson.c
	$(CC) $(CFLAGS) -o $@ tests.c parson.c
	./$@

testcpp: tests.c parson.c
	$(CPPC) $(CPPFLAGS) -o $@ tests.c parson.c
	./$@

test_hash_collisions: tests.c parson.c
	$(CC) $(CFLAGS) -DPARSON_FORCE_HASH_COLLISIONS -o $@ tests.c parson.c
	./$@

clean:
	rm -f test *.o

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  libedit-dev,
  libkrb5-dev,
  liblz4-dev,

## pgcopydb 0.16

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # Licensed under the PostgreSQL License.
 
 TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
+PGCOPYDB ?= $(TOP)src/bin/pgcopydb/pgcopydb
 
 all: bin ;
 
@@ -10,6 +11,9 @@
 
 bin: GIT-VERSION-FILE
 	$(MAKE) -C src/bin/ all
+
+sqlite3:
+	$(MAKE) -C src/bin/lib/sqlite $@
 
 clean:
 	rm -f GIT-VERSION-FILE
@@ -21,7 +25,7 @@
 docs:
 	$(MAKE) -C docs clean man html
 
-update-docs: install
+update-docs: bin
 	bash ./docs/update-help-messages.sh
 
 test: build
@@ -66,7 +70,7 @@
 	docker run --rm -it pgcopydb_debian_qa bash
 
 .PHONY: all
-.PHONY: bin clean install docs maintainer-clean
+.PHONY: bin clean install docs maintainer-clean update-docs
 .PHONY: test tests tests/ci tests/*
 .PHONY: deb debsh deb-qa debsh-qa
 .PHONY: GIT-VERSION-FILE

=== src/bin/pgcopydb/Makefile ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 DEPDIR = $(SRC_DIR)/.deps
 
+SQLITE3_DIR = $(SRC_DIR)../lib/sqlite/
+SQLITE3_LIB = $(SQLITE3_DIR)sqlite3.o
+
 INCLUDES  = $(patsubst ${SRC_DIR}%.h,%.h,$(wildcard ${SRC_DIR}*.h))
 
 SRC   = $(patsubst ${SRC_DIR}%.c,%.c,$(wildcard ${SRC_DIR}*.c))
@@ -16,6 +19,7 @@
 OBJS += lib-log.o lib-commandline.o lib-parson.o
 OBJS += lib-snprintf.o lib-strerror.o lib-dumputils.o lib-string_utils.o
 OBJS += lib-lookup3.o
+OBJS += lib-sqlite3.o
 
 PG_CONFIG ?= pg_config
 BINDIR    ?= $(shell $(PG_CONFIG) --bindir)
@@ -34,6 +38,7 @@
 COMMON_LIBS += -I${SRC_DIR}../lib/parson/
 COMMON_LIBS += -I${SRC_DIR}../lib/uthash/
 COMMON_LIBS += -I${SRC_DIR}../lib/jenkins/
+COMMON_LIBS += -I${SRC_DIR}../lib/sqlite/
 
 CC = $(shell $(PG_CONFIG) --cc)
 
@@ -63,15 +68,28 @@
 DEFAULT_CFLAGS += -Wno-missing-braces
 DEFAULT_CFLAGS += $(COMMON_LIBS)
 
-ifdef USE_SECURITY_FLAGS
+# Needed for ARM64 based OSX
+ifeq ($(shell uname -s),Darwin)
+	ifeq ($(shell uname -m),arm64)
+		DEFAULT_CFLAGS += -I/opt/homebrew/include
+	endif
+endif
+
+
 # Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
-SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpie -Wl,-pie -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
+SECURITY_CFLAGS = -fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2
+SECURITY_CFLAGS += -fpie -Wl,-pie
+SECURITY_CFLAGS += -Wformat -Wformat-security -Werror=format-security
+
+ifneq ($(shell uname -s),Darwin)
+SECURITY_CFLAGS += -z noexecstack -Wl,-z,relro -Wl,-z,now
+endif
+
 DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
-endif
 
 override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)
 
-JENKINS_CFLAGS = $(CFAGS) -Wno-implicit-fallthrough -Wno-format
+JENKINS_CFLAGS = $(CFLAGS) -Wno-implicit-fallthrough
 
 LIBS  = -L $(shell $(PG_CONFIG) --pkglibdir)
 LIBS += -L $(shell $(PG_CONFIG) --libdir)
@@ -79,9 +97,16 @@
 LIBS += $(shell $(PG_CONFIG) --libs)
 LIBS += -lpq
 LIBS += -lncurses
-LIBS += -lsqlite3
+LIBS += -lgc
 
-all: $(PGCOPYDB) ;
+# Needed for ARM64 based OSX
+ifeq ($(shell uname -s),Darwin)
+	ifeq ($(shell uname -m),arm64)
+		LIBS += -L/opt/homebrew/lib
+	endif
+endif
+
+all: $(PGCOPYDB) $(SQLITE3) ;
 
 # Based on Postgres Makefile for automatic dependency generation
 # https://github.com/postgres/postgres/blob/1933ae629e7b706c6c23673a381e778819db307d/src/Makefile.global.in#L890-L924
@@ -97,6 +122,12 @@
 
 $(PGCOPYDB): VERSION-FILE $(OBJS) $(INCLUDES)
 	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(LIBS) -o $@
+
+$(SQLITE3_LIB):
+	$(MAKE) -C $(SQLITE3_DIR) sqlite3.o
+
+lib-sqlite3.o: $(SQLITE3_LIB)
+	ln -sf $(SQLITE3_LIB) $@
 
 lib-snprintf.o: $(PG_SNPRINTF)
 	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/snprintf.c
@@ -130,13 +161,12 @@
 clean:
 	rm -f git-version.h
 	rm -f $(OBJS) $(PGCOPYDB)
+	$(MAKE) -C $(SQLITE3_DIR) clean
 	rm -rf $(DEPDIR)
 
 install: $(PGCOPYDB)
 	install -d $(DESTDIR)$(BINDIR)
 	install -m 0755 $(PGCOPYDB) $(DESTDIR)$(BINDIR)
 
-
-
 .PHONY: all monitor clean
 .PHONY: VERSION-FILE

=== src/bin/lib/sqlite/Makefile ===
# See https://sqlite.org/howtocompile.html

SRC = $(wildcard *.c)
INC = $(wildcard *.h)
OBJS = $(patsubst %.c,%.o,$(SRC))

PG_CONFIG ?= pg_config

CC = $(shell $(PG_CONFIG) --cc)
DEFAULT_CFLAGS = $(shell $(PG_CONFIG) --cflags)

ifdef DEBUG
# Use optimization option that provides good debugging experience
# https://gcc.gnu.org/onlinedocs/gcc/Optimize-Options.html.
# It overrides '-O2' flag of pg_config.
DEFAULT_CFLAGS += -Og
endif

SQLITE_CFLAGS += -DSQLITE_THREADSAFE=0
SQLITE_CFLAGS += -DSQLITE_OMIT_LOAD_EXTENSION
SQLITE_CFLAGS += -DHAVE_READLINE
SQLITE_CFLAGS += -DSQLITE_ENABLE_MATH_FUNCTIONS
#SQLITE_CFLAGS += -DSQLITE_ENABLE_NORMALIZE

SQLITE_CFLAGS += -Wno-missing-prototypes
SQLITE_CFLAGS += -Wno-implicit-fallthrough

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS) $(SQLITE_CFLAGS)

LIBS += -lm
LIBS += -lreadline
LIBS += -lncurses

sqlite3: $(SRC) $(INC)
	$(CC) $(CFLAGS) $(LIBS) $(SRC) -o $@

sqlite3.o: sqlite3.c sqlite3.h sqlite3ext.h
	$(CC) -c $(CFLAGS) $< -o $@

clean:
	rm -f $(OBJS) sqlite3

=== debian/changelog ===
pgcopydb (0.16-1) unstable; urgency=medium

  * Official 0.16 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 22 May 2024 17:36:18 +0200

pgcopydb (0.15-1) unstable; urgency=medium

  * Official 0.15 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 10 Jan 2024 15:45:29 +0100

## pgcopydb 0.17

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,9 @@
 	rm -f GIT-VERSION-FILE
 	$(MAKE) -C src/bin/ clean
 
-maintainer-clean: clean
+maintainer-clean:
+	rm -f GIT-VERSION-FILE
+	$(MAKE) -C src/bin/ maintainer-clean
 	rm -f version
 
 docs:
@@ -27,6 +29,11 @@
 
 update-docs: bin
 	bash ./docs/update-help-messages.sh
+
+check-docs:
+	cat Dockerfile ci/Dockerfile.docs.template > ci/Dockerfile.docs
+	docker build --file=ci/Dockerfile.docs --tag test-docs .
+	docker run test-docs
 
 test: build
 	$(MAKE) -C tests all

=== docs/requirements.txt ===
# Defining the exact version will make sure things don't break
sphinx
sphinx_rtd_theme
readthedocs-sphinx-search

=== tests/Makefile ===
--- 
+++ 
@@ -13,6 +13,9 @@
 	$(MAKE) -C $@
 
 pagila-multi-steps: build
+	$(MAKE) -C $@
+
+pagila-standby: build
 	$(MAKE) -C $@
 
 blobs: build

=== src/bin/Makefile ===
--- 
+++ 
@@ -9,6 +9,10 @@
 clean:
 	$(MAKE) -C pgcopydb clean
 
+maintainer-clean:
+	$(MAKE) -C pgcopydb clean
+	$(MAKE) -C lib/sqlite clean
+
 install: $(pgcopydb)
 	$(MAKE) -C pgcopydb install

=== tests/blobs/Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 test: down run down ;
 
 run: build
-	docker-compose run test
+	docker compose run test
 
 down:
-	docker-compose down
+	docker compose down
 
 build:
-	docker-compose build --quiet
+	docker compose build --quiet
 
 import:
 	psql --single-transaction --no-psqlrc -f import.sql

=== tests/cdc-endpos-between-transaction/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

test: down run down ;

run: build
	docker compose run test

down:
	docker compose down

build:
	docker compose build --quiet

.PHONY: run down build test

=== tests/cdc-wal2json/Makefile ===
--- 
+++ 
@@ -6,15 +6,15 @@
 test: down run down ;
 
 up: down build
-	docker-compose up $(COMPOSE_EXIT)
+	docker compose up $(COMPOSE_EXIT)
 
 run: build
-	docker-compose run test
+	docker compose run test
 
 down:
-	docker-compose down
+	docker compose down
 
 build:
-	docker-compose build --quiet
+	docker compose build --quiet
 
 .PHONY: run down build test

=== tests/follow-9.6/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

PGVERSION ?= 9.6
COMPOSE_EXIT = --exit-code-from=test --abort-on-container-exit

test: down run down ;

up: down build
	PGVERSION=$(PGVERSION) docker compose up $(COMPOSE_EXIT)

run: build
	PGVERSION=$(PGVERSION) docker compose run test

down:
	docker compose down
	rm -rf workdir/pgcopydb

build:
	PGVERSION=$(PGVERSION) docker compose build

.PHONY: run down build test

=== tests/follow-data-only/Makefile ===
--- 
+++ 
@@ -6,16 +6,16 @@
 test: down run down ;
 
 up: down build
-	docker-compose up $(COMPOSE_EXIT)
+	docker compose up $(COMPOSE_EXIT)
 
 run: build
-	docker-compose run test
+	docker compose run test
 
 down:
-	docker-compose down
+	docker compose down
 	rm -rf workdir/pgcopydb
 
 build:
-	docker-compose build --quiet
+	docker compose build --quiet
 
 .PHONY: run down build test

=== tests/pagila-standby/Makefile ===
# Copyright (c) 2021 The PostgreSQL Global Development Group.
# Licensed under the PostgreSQL License.

test: down run down ;

run: build
	docker compose run test

down:
	docker compose down

build:
	docker compose build --quiet

.PHONY: down build test

=== src/bin/pgcopydb/Makefile ===
--- 
+++ 
@@ -161,7 +161,6 @@
 clean:
 	rm -f git-version.h
 	rm -f $(OBJS) $(PGCOPYDB)
-	$(MAKE) -C $(SQLITE3_DIR) clean
 	rm -rf $(DEPDIR)
 
 install: $(PGCOPYDB)

=== src/bin/lib/sqlite/Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 LIBS += -lncurses
 
 sqlite3: $(SRC) $(INC)
-	$(CC) $(CFLAGS) $(LIBS) $(SRC) -o $@
+	$(CC) $(CFLAGS) $(SRC) $(LIBS) -o $@
 
 sqlite3.o: sqlite3.c sqlite3.h sqlite3ext.h
 	$(CC) -c $(CFLAGS) $< -o $@

=== debian/changelog ===
pgcopydb (0.17-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 07 Aug 2024 15:17:18 +0200

pgcopydb (0.17-1) unstable; urgency=medium

  * Official 0.17 release of pgcopydb

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 07 Aug 2024 15:17:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 12),
  libedit-dev,
+ libgc-dev,
  libkrb5-dev,
  liblz4-dev,
  libncurses-dev,
  libpam0g-dev,
  libreadline-dev,
  libselinux1-dev,
- libsqlite3-dev,
  libssl-dev,
  libxslt1-dev,
  libzstd-dev,
